"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = require("../color");
var log_1 = require("../log");
var Usage = (function () {
    function Usage() {
        this.X = new Array();
        this.Y = new Array();
    }
    Object.defineProperty(Usage.prototype, "x", {
        get: function () {
            return this.X;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Usage.prototype, "y", {
        get: function () {
            return this.Y;
        },
        enumerable: true,
        configurable: true
    });
    Usage.EMPTY = { x: [], y: [] };
    return Usage;
}());
exports.Usage = Usage;
var CPUUsage = (function (_super) {
    __extends(CPUUsage, _super);
    function CPUUsage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CPUUsage.prototype.push = function (stat) {
        var time = stat.read.substring(11, 19);
        var total = stat.cpu_stats.cpu_usage.total_usage - stat.precpu_stats.cpu_usage.total_usage;
        var system = stat.cpu_stats.system_cpu_usage - stat.precpu_stats.system_cpu_usage;
        var num = stat.cpu_stats.cpu_usage.percpu_usage.length;
        if (system > 0.0) {
            var percent = (total / system) * num * 100;
            if (this.y.length >= 30) {
                this.y.shift();
                this.x.shift();
            }
            this.y.push(percent);
            this.x.push(time);
        }
    };
    return CPUUsage;
}(Usage));
exports.CPUUsage = CPUUsage;
var RXData = (function (_super) {
    __extends(RXData, _super);
    function RXData() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(RXData.prototype, "title", {
        get: function () {
            return "RX";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RXData.prototype, "style", {
        get: function () {
            return {
                line: color_1.Color.magenta
            };
        },
        enumerable: true,
        configurable: true
    });
    RXData.prototype.push = function (stat) {
        var time = stat.read.substring(11, 19);
        var preValue = 0;
        if (this.y.length > 0) {
            preValue = this.y[this.y.length - 1];
        }
        var rxData = (stat.networks.eth0.rx_bytes - preValue) / 1024;
        if (this.y.length >= 30) {
            this.y.shift();
            this.x.shift();
        }
        this.y.push(Number(rxData.toFixed(0)));
        this.x.push(time);
    };
    return RXData;
}(Usage));
exports.RXData = RXData;
var TXData = (function (_super) {
    __extends(TXData, _super);
    function TXData() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(TXData.prototype, "title", {
        get: function () {
            return "TX";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TXData.prototype, "style", {
        get: function () {
            return {
                line: color_1.Color.yellow
            };
        },
        enumerable: true,
        configurable: true
    });
    TXData.prototype.push = function (stat) {
        var time = stat.read.substring(11, 19);
        var preValue = 0;
        if (this.y.length > 0) {
            preValue = this.y[this.y.length - 1];
        }
        var txData = (stat.networks.eth0.tx_bytes - preValue) / 1024;
        if (this.y.length >= 30) {
            this.y.shift();
            this.x.shift();
        }
        this.y.push(Number(txData.toFixed(0)));
        this.x.push(time);
    };
    return TXData;
}(Usage));
exports.TXData = TXData;
exports.EMPTY_NET_DATA = [new RXData(), new TXData()];
var MemoryUsage = (function (_super) {
    __extends(MemoryUsage, _super);
    function MemoryUsage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MemoryUsage.prototype.push = function (stat) {
        var time = stat.read.substring(11, 19);
        var usage = stat.memory_stats.usage / 1024 / 1024;
        if (this.y.length >= 30) {
            this.y.shift();
            this.x.shift();
        }
        this.y.push(usage);
        this.x.push(time);
    };
    return MemoryUsage;
}(Usage));
exports.MemoryUsage = MemoryUsage;
var Container = (function () {
    function Container(container) {
        this.container = container;
    }
    Container.prototype.stat = function () {
        return __awaiter(this, void 0, void 0, function () {
            var stream;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.container) {
                            throw new Error("container is null.");
                        }
                        return [4, this.container.stats()];
                    case 1:
                        stream = _a.sent();
                        return [2, new StatsStream(stream)];
                }
            });
        });
    };
    Container.prototype.inspect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.container) {
                            throw new Error("container is null.");
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.container.inspect()];
                    case 2:
                        data = _a.sent();
                        return [2, JSON.stringify(data, null, 2)];
                    case 3:
                        error_1 = _a.sent();
                        log_1.Log.error(error_1);
                        return [3, 4];
                    case 4: return [2, ""];
                }
            });
        });
    };
    return Container;
}());
exports.Container = Container;
var StatsStream = (function () {
    function StatsStream(stream) {
        this.stream = stream;
    }
    StatsStream.prototype.ondata = function (callback) {
        if (this.stream) {
            var cpuUsage_1 = new CPUUsage();
            var memUsage_1 = new MemoryUsage();
            var txData_1 = new TXData();
            var rxData_1 = new RXData();
            this.stream.on('data', function (chunk) {
                var stat = JSON.parse(chunk.toString());
                cpuUsage_1.push(stat);
                memUsage_1.push(stat);
                txData_1.push(stat);
                rxData_1.push(stat);
                callback(cpuUsage_1, memUsage_1, txData_1, rxData_1);
            });
        }
    };
    StatsStream.prototype.end = function () {
        if (this.stream) {
            this.stream.emit('end');
        }
    };
    return StatsStream;
}());
exports.StatsStream = StatsStream;
