"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = require("../color");
var log_1 = require("../log");
var container_1 = require("./container");
var Docker = require('dockerode');
var moment = require('moment');
var Dockerode = (function () {
    function Dockerode() {
        this.docker = new Docker({
            socketPath: '/var/run/docker.sock'
        });
    }
    Object.defineProperty(Dockerode, "singleton", {
        get: function () {
            if (!this.instance) {
                this.instance = new Dockerode();
            }
            return this.instance;
        },
        enumerable: true,
        configurable: true
    });
    Dockerode.prototype.getContainer = function (selectId) {
        return new container_1.Container(this.docker.getContainer(selectId));
    };
    Dockerode.prototype.version = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, version, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [[color_1.ColorText.title('Docker Version'), '']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.version()];
                    case 2:
                        version = _a.sent();
                        if (!version) {
                            return [2, data];
                        }
                        data.push([color_1.ColorText.blue('Docker version'), version.Version]);
                        data.push([color_1.ColorText.blue('Docker api version'), version.ApiVersion]);
                        data.push([color_1.ColorText.blue('Go version'), version.GoVersion]);
                        data.push([color_1.ColorText.blue('Build'), version.GitCommit]);
                        data.push([color_1.ColorText.blue('Build time'), version.BuildTime]);
                        data.push([color_1.ColorText.blue('Experimental'), version.Experimental ? version.Experimental : "--"]);
                        return [3, 4];
                    case 3:
                        error_1 = _a.sent();
                        log_1.Log.error(error_1);
                        data.push(["Error", error_1.errno]);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    Dockerode.prototype.information = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, info, isSwarm, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [['', ''], [color_1.ColorText.title('Swarm Info'), '']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.info()];
                    case 2:
                        info = _a.sent();
                        if (!info) {
                            return [2, data];
                        }
                        isSwarm = this.isSwarm(info);
                        if (isSwarm) {
                            data.push([color_1.ColorText.blue('(This node is part of a Swarm cluster)'), '']);
                        }
                        data.push([color_1.ColorText.blue('Node role'), isSwarm ? this.role(info.Swarm) : '-']);
                        data.push([color_1.ColorText.blue('Node id'), isSwarm ? info.Swarm.NodeID : '-']);
                        data.push([color_1.ColorText.blue('Nodes in the cluster'), isSwarm ? info.Swarm.Nodes.toString() : '-']);
                        data.push([color_1.ColorText.blue('Managers in the cluster'), isSwarm ? info.Swarm.Managers.toString() : '-']);
                        data.push(['', '']);
                        data.push([color_1.ColorText.title('Containers'), '']);
                        data.push([color_1.ColorText.blue('Total'), info.Containers.toString()]);
                        data.push([color_1.ColorText.blue('Running'), color_1.ColorText.cyan(info.ContainersRunning.toString())]);
                        data.push([color_1.ColorText.blue('Stopped'), color_1.ColorText.red(info.ContainersStopped.toString())]);
                        data.push([color_1.ColorText.blue('Paused'), color_1.ColorText.yellow(info.ContainersPaused.toString())]);
                        return [3, 4];
                    case 3:
                        error_2 = _a.sent();
                        log_1.Log.error(error_2);
                        data.push(["Error", error_2.errno]);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    Dockerode.prototype.isSwarm = function (info) {
        return info.Swarm && info.Swarm.LocalNodeState === 'active';
    };
    Dockerode.prototype.role = function (swarm) {
        var localId = swarm.NodeID;
        var isLeader = false;
        swarm.RemoteManagers.forEach(function (rm) {
            if (rm.NodeID == localId) {
                isLeader = true;
            }
        });
        return isLeader ? 'Leader' : 'Follower';
    };
    Dockerode.prototype.listImages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, images, error_3;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [['Id', 'Repository', 'Tag', 'Size', 'Created']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.listImages()];
                    case 2:
                        images = _a.sent();
                        if (!images) {
                            return [2, data];
                        }
                        images.forEach(function (image) {
                            var repoTag = _this.getRepoTag(image.RepoTags);
                            var size = (image.Size / 1000 / 1000).toFixed(2) + ' MB';
                            var created = moment(new Date(image.Created * 1000), 'YYYYMMDD').fromNow();
                            data.push([_this.getId(image.Id), repoTag.repo, repoTag.tag, size, created]);
                        });
                        return [3, 4];
                    case 3:
                        error_3 = _a.sent();
                        log_1.Log.error(error_3);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    Dockerode.prototype.totalImages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, images, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [['', ''], [color_1.ColorText.title('Images'), '']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.listImages()];
                    case 2:
                        images = _a.sent();
                        if (!images) {
                            return [2, data];
                        }
                        data.push([color_1.ColorText.blue('Total'), images.length ? images.length.toString() : '0']);
                        data.push([color_1.ColorText.blue('Size'), this.sizeOf(images) + ' GB']);
                        return [3, 4];
                    case 3:
                        error_4 = _a.sent();
                        log_1.Log.error(error_4);
                        data.push(["Error", error_4.errno]);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    Dockerode.prototype.getRepoTag = function (repoTags) {
        var repo = {
            repo: '',
            tag: ''
        };
        if (repoTags && repoTags.length && repoTags.length > 0) {
            var tmp = repoTags[0].toString();
            var index = tmp.lastIndexOf(':');
            if (index >= 0) {
                repo.repo = tmp.substring(0, index);
                repo.tag = tmp.substring(index + 1, tmp.length);
            }
            else {
                repo.repo = tmp;
            }
        }
        return repo;
    };
    Dockerode.prototype.getId = function (id) {
        if (!id)
            return '-';
        var index = id.indexOf(':');
        if (index >= 0) {
            return id.substring(index + 1, index + 13);
        }
        return id.substring(0, 12);
    };
    Dockerode.prototype.sizeOf = function (images) {
        var total = images.reduce(function (total, image) { return total + image.Size / 1000 / 1000; }, 0);
        return (total / 1000).toFixed(2);
    };
    Dockerode.prototype.listContainers = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, containers, error_5;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [['Id', 'Name', 'Image', 'IP', 'Ports', 'State']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.listContainers({ all: true })];
                    case 2:
                        containers = _a.sent();
                        if (!containers) {
                            return [2, data];
                        }
                        containers.forEach(function (container) {
                            data.push(_this.toRow(container));
                        });
                        return [3, 4];
                    case 3:
                        error_5 = _a.sent();
                        log_1.Log.error(error_5);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    Dockerode.prototype.toRow = function (container) {
        var row = [];
        row.push(container.Id.substring(0, 8));
        if (container.Names.length > 0) {
            var name = container.Names[0];
            row.push(name.substring(1, name.length));
        }
        else {
            row.push('-');
        }
        row.push(container.Image);
        if (container.State == 'running') {
            var mode = container.HostConfig.NetworkMode;
            row.push(container.NetworkSettings.Networks[mode == 'default' ? 'bridge' : mode].IPAddress);
            if (container.Ports.length > 0) {
                var port = container.Ports[0];
                row.push(port.PrivatePort + ':' + port.PublicPort);
            }
            else {
                row.push('-');
            }
            row.push('{bold}{cyan-bg}{white-fg}running{/white-fg}{/cyan-bg}{/bold}');
        }
        else {
            row.push('-');
            row.push('-');
            row.push('{bold}{red-bg}{white-fg}stopped{/white-fg}{/red-bg}{/bold}');
        }
        return row;
    };
    ;
    Dockerode.prototype.listNetworks = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, nets, error_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [['Name', 'Id', 'Scope', 'Driver', 'IPAM Driver', 'IPAM Subnet', 'IPAM Gateway']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.listNetworks()];
                    case 2:
                        nets = _a.sent();
                        nets.forEach(function (net) {
                            var row = [net.Name, net.Id, net.Scope, net.Driver];
                            if (!net.IPAM) {
                                row.push(net.IPAM.Driver);
                                if (net.IPAM.Config.length > 0) {
                                    var c = net.IPAM.Config[0];
                                    row.push(!c.Subnet ? '-' : c.Subnet);
                                    row.push(!c.Gateway ? '-' : c.Gateway);
                                }
                            }
                            data.push(row);
                        });
                        return [3, 4];
                    case 3:
                        error_6 = _a.sent();
                        log_1.Log.error(error_6);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    Dockerode.prototype.listVolumes = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, result, error_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = [['Name', 'Driver', 'Mountpoint']];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, this.docker.listVolumes()];
                    case 2:
                        result = _a.sent();
                        if (!result || !result.Volumes) {
                            return [2, data];
                        }
                        result.Volumes.forEach(function (volume) { return data.push([volume.Name, volume.Driver, volume.Mountpoint]); });
                        return [3, 4];
                    case 3:
                        error_7 = _a.sent();
                        log_1.Log.error(error_7);
                        return [3, 4];
                    case 4: return [2, data];
                }
            });
        });
    };
    return Dockerode;
}());
exports.Dockerode = Dockerode;
