"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var widgetfactory_1 = require("./widgets/widgetfactory");
var widgetrender_1 = require("./common/widgetrender");
var DockerDashboard = (function () {
    function DockerDashboard() {
        this.widgetFactory = new widgetfactory_1.WidgetFactory(this);
        this.activeElement = this.widgetFactory.getDefault();
    }
    DockerDashboard.prototype.startup = function () {
        this.dashboard = widgetrender_1.WidgetRender.form("🐳 Docker Dashboard");
        this.dashboard.key(["q"], function () {
            return process.exit(0);
        });
        widgetrender_1.WidgetRender.menuBar(this.dashboard, this.widgetFactory.getCommands());
        this.box = widgetrender_1.WidgetRender.box(this.dashboard);
        this.activeElement.render();
        this.dashboard.render();
    };
    DockerDashboard.prototype.getBox = function () {
        return this.box;
    };
    DockerDashboard.prototype.active = function (element) {
        this.activeElement.hide();
        this.activeElement = element;
        this.activeElement.show();
        this.dashboard.render();
    };
    DockerDashboard.prototype.getDashboard = function () {
        return this.dashboard;
    };
    return DockerDashboard;
}());
exports.DockerDashboard = DockerDashboard;
