"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var widgetrender_1 = require("../common/widgetrender");
var widget_1 = require("./widget");
var dockerode_1 = require("../common/docker/dockerode");
var log_1 = require("../common/log");
var container_1 = require("../common/docker/container");
var ContainerWidget = (function (_super) {
    __extends(ContainerWidget, _super);
    function ContainerWidget(dockerdashboard) {
        var _this = _super.call(this, dockerdashboard) || this;
        _this.selectId = "";
        return _this;
    }
    ContainerWidget.prototype.getCommandName = function () {
        return "Containers";
    };
    ContainerWidget.prototype.getCommandKey = function () {
        var _this = this;
        return {
            keys: ["c"],
            callback: function () {
                if (!_this.table) {
                    _this.render();
                    _this.table.focus();
                }
                _this.active();
            }
        };
    };
    ContainerWidget.prototype.hide = function () {
        this.hideAll(this.table, this.text, this.mem, this.cpu, this.net, this.log);
    };
    ContainerWidget.prototype.show = function () {
        this.showAll(this.table, this.text, this.mem, this.cpu, this.net, this.log);
        this.table.focus();
    };
    ContainerWidget.prototype.renderWidget = function (box) {
        return __awaiter(this, void 0, void 0, function () {
            var data, error_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.table = widgetrender_1.WidgetRender.table(box, 0, 0, "100%-2", "40%-2", "Containers");
                        return [4, dockerode_1.Dockerode.singleton.listContainers()];
                    case 1:
                        data = _a.sent();
                        this.table.setData(data);
                        this.table.on("select", function (container) {
                            _this.showSelectContainer(container);
                        });
                        return [3, 3];
                    case 2:
                        error_1 = _a.sent();
                        log_1.Log.error(error_1);
                        return [3, 3];
                    case 3:
                        this.text = widgetrender_1.WidgetRender.text(box, "40%-2", 0, "100%-2", 2, "{bold}✔  Container Stats{bold}");
                        this.cpu = widgetrender_1.WidgetRender.line({ top: "40%", left: 0 }, "50%-1", "30%", "red", "CPU Usage (%)");
                        box.append(this.cpu);
                        this.mem = widgetrender_1.WidgetRender.line({ top: "40%", right: 0 }, "50%-1", "30%", "magenta", "Memory Usage (MB)");
                        box.append(this.mem);
                        this.net = widgetrender_1.WidgetRender.line({ left: 0, bottom: 0 }, "50%-1", "30%-1", "white", "Network Usage (KB)", true);
                        box.append(this.net);
                        this.log = widgetrender_1.WidgetRender.inspectBox(box, 0, 0, "50%-1", "30%-1", " Inspect ");
                        return [2];
                }
            });
        });
    };
    ContainerWidget.prototype.showSelectContainer = function (containerItem) {
        return __awaiter(this, void 0, void 0, function () {
            var selectId, container, inspectData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        selectId = containerItem.content.substring(0, 8);
                        if (this.selectId == selectId) {
                            return [2];
                        }
                        this.selectId = selectId;
                        this.clearData();
                        this.text.setContent("{bold}✔ Container Stats (" + selectId + "){bold}");
                        this.refresh();
                        container = dockerode_1.Dockerode.singleton.getContainer(selectId);
                        if (!this.isRunning(selectId)) {
                            return [2];
                        }
                        return [4, container.inspect()];
                    case 1:
                        inspectData = _a.sent();
                        this.log.setContent(inspectData);
                        return [4, this.showStatsCharts(container)];
                    case 2:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    ContainerWidget.prototype.clearData = function () {
        if (this.stream) {
            this.stream.end();
        }
        this.cpu.setData(container_1.Usage.EMPTY);
        this.mem.setData(container_1.Usage.EMPTY);
        this.net.setData(container_1.EMPTY_NET_DATA);
        this.log.setContent("");
    };
    ContainerWidget.prototype.showStatsCharts = function (container) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4, container.stat()];
                    case 1:
                        _a.stream = _b.sent();
                        this.stream.ondata(function (cpuuage, memUsage, txData, rxData) {
                            _this.cpu.setData(cpuuage);
                            _this.mem.setData(memUsage);
                            _this.net.setData([txData, rxData]);
                            _this.refresh();
                        });
                        return [2];
                }
            });
        });
    };
    ContainerWidget.prototype.isRunning = function (selectId) {
        if (this.table) {
            var row = this.table.rows.find(function (row) { return row[0] === selectId; });
            if (row) {
                return row[5].indexOf("running") >= 0;
            }
        }
        return false;
    };
    return ContainerWidget;
}(widget_1.Widget));
exports.ContainerWidget = ContainerWidget;
