"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var widget_1 = require("./widget");
var widgetrender_1 = require("../common/widgetrender");
var HelpWidget = (function (_super) {
    __extends(HelpWidget, _super);
    function HelpWidget(dockerdashboard) {
        return _super.call(this, dockerdashboard) || this;
    }
    HelpWidget.prototype.getCommandName = function () {
        return "Help";
    };
    HelpWidget.prototype.getCommandKey = function () {
        var _this = this;
        return {
            keys: ["h"],
            callback: function () {
                if (!_this.helpBox) {
                    _this.render();
                }
                _this.active();
            }
        };
    };
    HelpWidget.prototype.hide = function () {
        this.helpBox.hide();
    };
    HelpWidget.prototype.show = function () {
        this.helpBox.show();
    };
    HelpWidget.prototype.renderWidget = function (box) {
        var content = '\n' +
            '   Shortcut\n' +
            '   -----------------------------------------------------------------\n' +
            '   D       :  show node info.\n' +
            '   C       :  show container list.\n' +
            '   I       :  show iamge list.\n' +
            '   N       :  show network.\n' +
            '   V       :  show volume list.\n' +
            '   H       :  show help.\n' +
            '   Q       :  exit.\n' +
            '   \n' +
            '   About\n' +
            '   -----------------------------------------------------------------\n' +
            '   Github  :  https://github.com/pipiliang/docker-dashboard\n' +
            '   Issues  :  https://github.com/pipiliang/docker-dashboard/issues\n' +
            '   Lisence :  MIT\n' +
            '   Thanks  :  \n' +
            '              1. blessed \n' +
            '              2. blessed-contrib \n' +
            '              3. dockerode';
        this.helpBox = widgetrender_1.WidgetRender.helpBox(box, content);
    };
    return HelpWidget;
}(widget_1.Widget));
exports.HelpWidget = HelpWidget;
