"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var widgetrender_1 = require("../common/widgetrender");
var color_1 = require("../common/color");
var widget_1 = require("./widget");
var dockerode_1 = require("../common/docker/dockerode");
var log_1 = require("../common/log");
var os = require('os');
var HomeWidget = (function (_super) {
    __extends(HomeWidget, _super);
    function HomeWidget(dockerdashboard) {
        return _super.call(this, dockerdashboard) || this;
    }
    HomeWidget.prototype.getCommandName = function () {
        return "Dashboard";
    };
    HomeWidget.prototype.getCommandKey = function () {
        var _this = this;
        return {
            keys: ["d"],
            callback: function () {
                if (!_this.table) {
                    _this.render();
                }
                _this.active();
            }
        };
    };
    HomeWidget.prototype.hide = function () {
        this.table.hide();
    };
    HomeWidget.prototype.show = function () {
        this.table.show();
    };
    HomeWidget.prototype.renderWidget = function (box) {
        return __awaiter(this, void 0, void 0, function () {
            var data, versionData, dockerInfo, images, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.table = widgetrender_1.WidgetRender.table(box, 0, 0, "100%-2", "100%-2", "");
                        data = [
                            [color_1.ColorText.title("Node Info"), ""],
                            [color_1.ColorText.blue('Name'), os.hostname()],
                            [color_1.ColorText.blue("OS"), os.platform() + "-" + os.arch()],
                            [color_1.ColorText.blue("Release"), os.release()],
                            [color_1.ColorText.blue("CPUs"), this.getCPUs()],
                            [color_1.ColorText.blue("Memory"), (os.totalmem() / 1000 / 1000 / 1000).toFixed(1) + " GB"],
                            [color_1.ColorText.blue("Up Time"), (os.uptime() / 60 / 60).toFixed(0) + " Hours"]
                        ];
                        data.push(["", ""]);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        return [4, dockerode_1.Dockerode.singleton.version()];
                    case 2:
                        versionData = _a.sent();
                        versionData.forEach(function (vData) { return data.push(vData); });
                        return [4, dockerode_1.Dockerode.singleton.information()];
                    case 3:
                        dockerInfo = _a.sent();
                        dockerInfo.forEach(function (info) { return data.push(info); });
                        return [4, dockerode_1.Dockerode.singleton.totalImages()];
                    case 4:
                        images = _a.sent();
                        images.forEach(function (image) { return data.push(image); });
                        return [3, 6];
                    case 5:
                        error_1 = _a.sent();
                        log_1.Log.info(error_1);
                        return [3, 6];
                    case 6:
                        this.table.setData(data);
                        this.refresh();
                        return [2];
                }
            });
        });
    };
    ;
    HomeWidget.prototype.getCPUs = function () {
        var cups = os.cpus();
        return (cups && cups.length) ? cups.length.toString() : "0";
    };
    return HomeWidget;
}(widget_1.Widget));
exports.HomeWidget = HomeWidget;
