"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var homewidget_1 = require("./homewidget");
var helpwidget_1 = require("./helpwidget");
var containerwidget_1 = require("./containerwidget");
var imagewidget_1 = require("./imagewidget");
var networkwidget_1 = require("./networkwidget");
var volumewideget_1 = require("./volumewideget");
var WidgetFactory = (function () {
    function WidgetFactory(dockerdashboard) {
        this.widgets = new Array();
        this.widgets.push(new homewidget_1.HomeWidget(dockerdashboard));
        this.widgets.push(new containerwidget_1.ContainerWidget(dockerdashboard));
        this.widgets.push(new imagewidget_1.ImageWidget(dockerdashboard));
        this.widgets.push(new networkwidget_1.NetworkWidget(dockerdashboard));
        this.widgets.push(new volumewideget_1.VolumeWidget(dockerdashboard));
        this.widgets.push(new helpwidget_1.HelpWidget(dockerdashboard));
    }
    WidgetFactory.prototype.getCommands = function () {
        var commands = {};
        this.widgets.forEach(function (widget) {
            commands[widget.getCommandName()] = widget.getCommandKey();
        });
        return commands;
    };
    WidgetFactory.prototype.getDefault = function () {
        return this.widgets[0];
    };
    return WidgetFactory;
}());
exports.WidgetFactory = WidgetFactory;
